//+------------------------------------------------------------------+
//|                            Holt double exponential smoothing.mq4 |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers  3
#property indicator_color1   LimeGreen
#property indicator_color2   Orange
#property indicator_color3   Orange
#property indicator_width1   2
#property indicator_width2   2
#property indicator_width3   2

//
//
//
//
//

extern double             estimatePeriod = 14.33;
extern double             trendPeriod    = 10;
extern ENUM_APPLIED_PRICE Price          = PRICE_CLOSE;

//
//
//
//
//

double emaBuffer[];
double emaBufferda[];
double emaBufferdb[];
double wrkBuffer[];
double slope[];
double alpha;
double gamma;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,emaBuffer);
   SetIndexBuffer(1,emaBufferda);
   SetIndexBuffer(2,emaBufferdb);
   SetIndexBuffer(3,wrkBuffer);
   SetIndexBuffer(4,slope);
      estimatePeriod = MathMax(estimatePeriod,1);
      trendPeriod    = MathMax(trendPeriod,1);
               alpha = 2.0 /(1.0+estimatePeriod);
               gamma = 2.0 /(1.0+trendPeriod);
      IndicatorShortName("Holt des ("+DoubleToStr(estimatePeriod,2)+","+DoubleToStr(trendPeriod,2)+")");
   return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         
   //
   //
   //
   //
   //
            
   if (slope[limit]==-1) CleanPoint(limit,emaBufferda,emaBufferdb);
   for(i=limit; i>=0; i--)
   {
      double price = iMA(NULL,0,1,0,MODE_SMA,Price,i);
         if (i>=(Bars-3))
         {
            emaBuffer[i] = price;
            wrkBuffer[i] = price-emaBuffer[i+1];
            continue;
         }
         
         emaBuffer[i] = alpha*price+(1-alpha)*(emaBuffer[i+1]+wrkBuffer[i+1]);
         wrkBuffer[i] = gamma*(emaBuffer[i]-emaBuffer[i+1]) + (1-gamma)*wrkBuffer[i+1];
         emaBufferda[i] = EMPTY_VALUE;
         emaBufferdb[i] = EMPTY_VALUE;
         slope[i]       = slope[i+1];
            if (emaBuffer[i]>emaBuffer[i+1]) slope[i] =  1;
            if (emaBuffer[i]<emaBuffer[i+1]) slope[i] = -1;
            if (slope[i]==-1) PlotPoint(i,emaBufferda,emaBufferdb,emaBuffer);
   }
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}
void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
         if (first[i+2] == EMPTY_VALUE) 
               {  first[i]  = from[i]; first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
         else  {  second[i] = from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
   else        {  first[i]  = from[i];                          second[i] = EMPTY_VALUE; }
}